diff --git a/pengine/test10/whitebox-imply-stop-on-fence.exp b/pengine/test10/whitebox-imply-stop-on-fence.exp
index 0bd42b762..e38f4ea97 100644
--- a/pengine/test10/whitebox-imply-stop-on-fence.exp
+++ b/pengine/test10/whitebox-imply-stop-on-fence.exp
@@ -1,33 +1,36 @@
 <transition_graph cluster-delay="60s" stonith-timeout="60s" failed-stop-offset="INFINITY" failed-start-offset="INFINITY"  transition_id="0">
   <synapse id="0">
     <action_set>
-      <rsc_op id="15" operation="monitor" operation_key="fence-kiff-02_monitor_60000" on_node="kiff-02" on_node_uuid="2">
+      <rsc_op id="14" operation="monitor" operation_key="fence-kiff-02_monitor_60000" on_node="kiff-02" on_node_uuid="2">
         <primitive id="fence-kiff-02" class="stonith" type="fence_ipmilan"/>
         <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_timeout="20000" action="reboot"  ipaddr="kiff-02-ilo" login="admin" passwd="admin" pcmk_host_check="static-list" pcmk_host_list="kiff-02"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="14" operation="start" operation_key="fence-kiff-02_start_0" on_node="kiff-02" on_node_uuid="2"/>
+        <rsc_op id="13" operation="start" operation_key="fence-kiff-02_start_0" on_node="kiff-02" on_node_uuid="2"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="1">
     <action_set>
-      <rsc_op id="14" operation="start" operation_key="fence-kiff-02_start_0" on_node="kiff-02" on_node_uuid="2">
+      <rsc_op id="13" operation="start" operation_key="fence-kiff-02_start_0" on_node="kiff-02" on_node_uuid="2">
         <primitive id="fence-kiff-02" class="stonith" type="fence_ipmilan"/>
         <attributes CRM_meta_timeout="20000" action="reboot"  ipaddr="kiff-02-ilo" login="admin" passwd="admin" pcmk_host_check="static-list" pcmk_host_list="kiff-02"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="13" operation="stop" operation_key="fence-kiff-02_stop_0"/>
+        <pseudo_event id="9" operation="all_stopped" operation_key="all_stopped"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="12" operation="stop" operation_key="fence-kiff-02_stop_0"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="2">
     <action_set>
-      <pseudo_event id="13" operation="stop" operation_key="fence-kiff-02_stop_0">
+      <pseudo_event id="12" operation="stop" operation_key="fence-kiff-02_stop_0">
         <attributes CRM_meta_timeout="20000" action="reboot"  ipaddr="kiff-02-ilo" login="admin" passwd="admin" pcmk_host_check="static-list" pcmk_host_list="kiff-02"/>
       </pseudo_event>
     </action_set>
@@ -35,16 +38,16 @@
   </synapse>
   <synapse id="3">
     <action_set>
-      <pseudo_event id="16" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0">
+      <pseudo_event id="15" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0">
         <attributes CRM_meta_clone="0" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="100000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="21" operation="stop" operation_key="dlm-clone_stop_0"/>
+        <pseudo_event id="20" operation="stop" operation_key="dlm-clone_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="23" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0"/>
+        <pseudo_event id="22" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0"/>
       </trigger>
       <trigger>
         <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
@@ -53,28 +56,28 @@
   </synapse>
   <synapse id="4" priority="1000000">
     <action_set>
-      <pseudo_event id="22" operation="stopped" operation_key="dlm-clone_stopped_0">
+      <pseudo_event id="21" operation="stopped" operation_key="dlm-clone_stopped_0">
         <attributes CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="16" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0"/>
+        <pseudo_event id="15" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="21" operation="stop" operation_key="dlm-clone_stop_0"/>
+        <pseudo_event id="20" operation="stop" operation_key="dlm-clone_stop_0"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="5">
     <action_set>
-      <pseudo_event id="21" operation="stop" operation_key="dlm-clone_stop_0">
+      <pseudo_event id="20" operation="stop" operation_key="dlm-clone_stop_0">
         <attributes CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="29" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
+        <pseudo_event id="28" operation="stopped" operation_key="clvmd-clone_stopped_0"/>
       </trigger>
       <trigger>
         <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
@@ -83,16 +86,16 @@
   </synapse>
   <synapse id="6">
     <action_set>
-      <pseudo_event id="23" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0">
+      <pseudo_event id="22" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0">
         <attributes CRM_meta_clone="0" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="90000"  with_cmirrord="1"/>
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="28" operation="stop" operation_key="clvmd-clone_stop_0"/>
+        <pseudo_event id="27" operation="stop" operation_key="clvmd-clone_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="30" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0"/>
+        <pseudo_event id="29" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0"/>
       </trigger>
       <trigger>
         <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
@@ -101,28 +104,28 @@
   </synapse>
   <synapse id="7" priority="1000000">
     <action_set>
-      <pseudo_event id="29" operation="stopped" operation_key="clvmd-clone_stopped_0">
+      <pseudo_event id="28" operation="stopped" operation_key="clvmd-clone_stopped_0">
         <attributes CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="23" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0"/>
+        <pseudo_event id="22" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="28" operation="stop" operation_key="clvmd-clone_stop_0"/>
+        <pseudo_event id="27" operation="stop" operation_key="clvmd-clone_stop_0"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="8">
     <action_set>
-      <pseudo_event id="28" operation="stop" operation_key="clvmd-clone_stop_0">
+      <pseudo_event id="27" operation="stop" operation_key="clvmd-clone_stop_0">
         <attributes CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="36" operation="stopped" operation_key="shared0-clone_stopped_0"/>
+        <pseudo_event id="35" operation="stopped" operation_key="shared0-clone_stopped_0"/>
       </trigger>
       <trigger>
         <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
@@ -131,13 +134,13 @@
   </synapse>
   <synapse id="9">
     <action_set>
-      <pseudo_event id="30" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0">
+      <pseudo_event id="29" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0">
         <attributes CRM_meta_clone="0" CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_name="stop" CRM_meta_notify="false" CRM_meta_timeout="60000"  device="/dev/shared/shared0" directory="/mnt/shared0" fstype="gfs2" options="errors=panic"/>
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="35" operation="stop" operation_key="shared0-clone_stop_0"/>
+        <pseudo_event id="34" operation="stop" operation_key="shared0-clone_stop_0"/>
       </trigger>
       <trigger>
         <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
@@ -146,31 +149,31 @@
   </synapse>
   <synapse id="10" priority="1000000">
     <action_set>
-      <pseudo_event id="36" operation="stopped" operation_key="shared0-clone_stopped_0">
+      <pseudo_event id="35" operation="stopped" operation_key="shared0-clone_stopped_0">
         <attributes CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="30" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0"/>
+        <pseudo_event id="29" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="35" operation="stop" operation_key="shared0-clone_stop_0"/>
+        <pseudo_event id="34" operation="stop" operation_key="shared0-clone_stop_0"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="11">
     <action_set>
-      <pseudo_event id="35" operation="stop" operation_key="shared0-clone_stop_0">
+      <pseudo_event id="34" operation="stop" operation_key="shared0-clone_stop_0">
         <attributes CRM_meta_clone_max="6" CRM_meta_clone_node_max="1" CRM_meta_globally_unique="false" CRM_meta_notify="false" CRM_meta_timeout="20000" />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="37" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0"/>
+        <pseudo_event id="36" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="40" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0"/>
+        <pseudo_event id="39" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0"/>
       </trigger>
       <trigger>
         <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
@@ -179,27 +182,27 @@
   </synapse>
   <synapse id="12">
     <action_set>
-      <rsc_op id="39" operation="monitor" operation_key="R-lxc-01_kiff-01_monitor_10000" on_node="kiff-02" on_node_uuid="2">
+      <rsc_op id="38" operation="monitor" operation_key="R-lxc-01_kiff-01_monitor_10000" on_node="kiff-02" on_node_uuid="2">
         <primitive id="R-lxc-01_kiff-01" class="ocf" provider="heartbeat" type="VirtualDomain"/>
         <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_remote_node="lxc-01_kiff-01" CRM_meta_timeout="30000" config="/mnt/shared0/test-virtual-domain/lxc/lxc-01_kiff-01.xml"  force_stop="true" hypervisor="lxc:///"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="38" operation="start" operation_key="R-lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
+        <rsc_op id="37" operation="start" operation_key="R-lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="13">
     <action_set>
-      <rsc_op id="38" operation="start" operation_key="R-lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2">
+      <rsc_op id="37" operation="start" operation_key="R-lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2">
         <primitive id="R-lxc-01_kiff-01" class="ocf" provider="heartbeat" type="VirtualDomain"/>
         <attributes CRM_meta_name="start" CRM_meta_remote_node="lxc-01_kiff-01" CRM_meta_timeout="90000" config="/mnt/shared0/test-virtual-domain/lxc/lxc-01_kiff-01.xml"  force_stop="true" hypervisor="lxc:///"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="37" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0"/>
+        <pseudo_event id="36" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0"/>
       </trigger>
       <trigger>
         <pseudo_event id="59" operation="stonith_complete" operation_key="stonith_complete"/>
@@ -208,7 +211,7 @@
   </synapse>
   <synapse id="14">
     <action_set>
-      <pseudo_event id="37" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0">
+      <pseudo_event id="36" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0">
         <attributes CRM_meta_name="stop" CRM_meta_remote_node="lxc-01_kiff-01" CRM_meta_timeout="90000" config="/mnt/shared0/test-virtual-domain/lxc/lxc-01_kiff-01.xml"  force_stop="true" hypervisor="lxc:///"/>
       </pseudo_event>
     </action_set>
@@ -223,27 +226,27 @@
   </synapse>
   <synapse id="15">
     <action_set>
-      <rsc_op id="42" operation="monitor" operation_key="R-lxc-02_kiff-01_monitor_10000" on_node="kiff-02" on_node_uuid="2">
+      <rsc_op id="41" operation="monitor" operation_key="R-lxc-02_kiff-01_monitor_10000" on_node="kiff-02" on_node_uuid="2">
         <primitive id="R-lxc-02_kiff-01" class="ocf" provider="heartbeat" type="VirtualDomain"/>
         <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_remote_node="lxc-02_kiff-01" CRM_meta_timeout="30000" config="/mnt/shared0/test-virtual-domain/lxc/lxc-02_kiff-01.xml"  force_stop="true" hypervisor="lxc:///"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="41" operation="start" operation_key="R-lxc-02_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
+        <rsc_op id="40" operation="start" operation_key="R-lxc-02_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="16">
     <action_set>
-      <rsc_op id="41" operation="start" operation_key="R-lxc-02_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2">
+      <rsc_op id="40" operation="start" operation_key="R-lxc-02_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2">
         <primitive id="R-lxc-02_kiff-01" class="ocf" provider="heartbeat" type="VirtualDomain"/>
         <attributes CRM_meta_name="start" CRM_meta_remote_node="lxc-02_kiff-01" CRM_meta_timeout="90000" config="/mnt/shared0/test-virtual-domain/lxc/lxc-02_kiff-01.xml"  force_stop="true" hypervisor="lxc:///"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="40" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0"/>
+        <pseudo_event id="39" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0"/>
       </trigger>
       <trigger>
         <pseudo_event id="59" operation="stonith_complete" operation_key="stonith_complete"/>
@@ -252,7 +255,7 @@
   </synapse>
   <synapse id="17">
     <action_set>
-      <pseudo_event id="40" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0">
+      <pseudo_event id="39" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0">
         <attributes CRM_meta_name="stop" CRM_meta_remote_node="lxc-02_kiff-01" CRM_meta_timeout="90000" config="/mnt/shared0/test-virtual-domain/lxc/lxc-02_kiff-01.xml"  force_stop="true" hypervisor="lxc:///"/>
       </pseudo_event>
     </action_set>
@@ -267,48 +270,48 @@
   </synapse>
   <synapse id="18">
     <action_set>
-      <rsc_op id="48" operation="start" operation_key="vm-fs_start_0" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01" router_node="kiff-02">
+      <rsc_op id="48" operation="monitor" operation_key="vm-fs_monitor_20000" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01" router_node="kiff-02">
         <primitive id="vm-fs" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_name="start" CRM_meta_timeout="60000"  device="/root" directory="/mnt/vm-fs" fstype="none" options="bind"/>
+        <attributes CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_timeout="40000"  device="/root" directory="/mnt/vm-fs" fstype="none" options="bind"/>
       </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="47" operation="stop" operation_key="vm-fs_stop_0"/>
+        <rsc_op id="47" operation="start" operation_key="vm-fs_start_0" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01" router_node="kiff-02"/>
       </trigger>
       <trigger>
         <rsc_op id="50" operation="start" operation_key="lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
       </trigger>
-      <trigger>
-        <pseudo_event id="59" operation="stonith_complete" operation_key="stonith_complete"/>
-      </trigger>
     </inputs>
   </synapse>
   <synapse id="19">
     <action_set>
-      <pseudo_event id="47" operation="stop" operation_key="vm-fs_stop_0">
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="60000"  device="/root" directory="/mnt/vm-fs" fstype="none" options="bind"/>
-      </pseudo_event>
+      <rsc_op id="47" operation="start" operation_key="vm-fs_start_0" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01" router_node="kiff-02">
+        <primitive id="vm-fs" class="ocf" provider="heartbeat" type="Filesystem"/>
+        <attributes CRM_meta_name="start" CRM_meta_timeout="60000"  device="/root" directory="/mnt/vm-fs" fstype="none" options="bind"/>
+      </rsc_op>
     </action_set>
     <inputs>
       <trigger>
-        <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
+        <pseudo_event id="46" operation="stop" operation_key="vm-fs_stop_0"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="50" operation="start" operation_key="lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="59" operation="stonith_complete" operation_key="stonith_complete"/>
       </trigger>
     </inputs>
   </synapse>
   <synapse id="20">
     <action_set>
-      <rsc_op id="9" operation="monitor" operation_key="vm-fs_monitor_20000" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01" router_node="kiff-02">
-        <primitive id="vm-fs" class="ocf" provider="heartbeat" type="Filesystem"/>
-        <attributes CRM_meta_interval="20000" CRM_meta_name="monitor" CRM_meta_timeout="40000"  device="/root" directory="/mnt/vm-fs" fstype="none" options="bind"/>
-      </rsc_op>
+      <pseudo_event id="46" operation="stop" operation_key="vm-fs_stop_0">
+        <attributes CRM_meta_name="stop" CRM_meta_timeout="60000"  device="/root" directory="/mnt/vm-fs" fstype="none" options="bind"/>
+      </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="48" operation="start" operation_key="vm-fs_start_0" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01" router_node="kiff-02"/>
-      </trigger>
-      <trigger>
-        <rsc_op id="50" operation="start" operation_key="lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
+        <pseudo_event id="61" operation="stonith" operation_key="stonith-lxc-01_kiff-01-reboot" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01"/>
       </trigger>
     </inputs>
   </synapse>
@@ -334,7 +337,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="38" operation="start" operation_key="R-lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
+        <rsc_op id="37" operation="start" operation_key="R-lxc-01_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
       </trigger>
       <trigger>
         <pseudo_event id="49" operation="stop" operation_key="lxc-01_kiff-01_stop_0"/>
@@ -378,7 +381,7 @@
     </action_set>
     <inputs>
       <trigger>
-        <rsc_op id="41" operation="start" operation_key="R-lxc-02_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
+        <rsc_op id="40" operation="start" operation_key="R-lxc-02_kiff-01_start_0" on_node="kiff-02" on_node_uuid="2"/>
       </trigger>
       <trigger>
         <pseudo_event id="52" operation="stop" operation_key="lxc-02_kiff-01_stop_0"/>
@@ -402,6 +405,36 @@
   </synapse>
   <synapse id="27">
     <action_set>
+      <pseudo_event id="62" operation="stonith" operation_key="stonith-lxc-02_kiff-01-reboot" on_node="lxc-02_kiff-01" on_node_uuid="lxc-02_kiff-01">
+        <attributes CRM_meta_on_node="lxc-02_kiff-01" CRM_meta_on_node_uuid="lxc-02_kiff-01" CRM_meta_stonith_action="reboot" />
+        <downed>
+          <node id="lxc-02_kiff-01"/>
+        </downed>
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="39" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="28">
+    <action_set>
+      <pseudo_event id="61" operation="stonith" operation_key="stonith-lxc-01_kiff-01-reboot" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01">
+        <attributes CRM_meta_on_node="lxc-01_kiff-01" CRM_meta_on_node_uuid="lxc-01_kiff-01" CRM_meta_stonith_action="reboot" />
+        <downed>
+          <node id="lxc-01_kiff-01"/>
+        </downed>
+      </pseudo_event>
+    </action_set>
+    <inputs>
+      <trigger>
+        <pseudo_event id="36" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0"/>
+      </trigger>
+    </inputs>
+  </synapse>
+  <synapse id="29">
+    <action_set>
       <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1">
         <attributes CRM_meta_on_node="kiff-01" CRM_meta_on_node_uuid="1" CRM_meta_probe_complete="true" CRM_meta_shutdown="0" CRM_meta_stonith_action="reboot" />
         <downed>
@@ -413,7 +446,7 @@
     </action_set>
     <inputs/>
   </synapse>
-  <synapse id="28">
+  <synapse id="30">
     <action_set>
       <pseudo_event id="59" operation="stonith_complete" operation_key="stonith_complete">
         <attributes />
@@ -423,35 +456,41 @@
       <trigger>
         <crm_event id="60" operation="stonith" operation_key="stonith-kiff-01-reboot" on_node="kiff-01" on_node_uuid="1"/>
       </trigger>
+      <trigger>
+        <pseudo_event id="61" operation="stonith" operation_key="stonith-lxc-01_kiff-01-reboot" on_node="lxc-01_kiff-01" on_node_uuid="lxc-01_kiff-01"/>
+      </trigger>
+      <trigger>
+        <pseudo_event id="62" operation="stonith" operation_key="stonith-lxc-02_kiff-01-reboot" on_node="lxc-02_kiff-01" on_node_uuid="lxc-02_kiff-01"/>
+      </trigger>
     </inputs>
   </synapse>
-  <synapse id="29">
+  <synapse id="31">
     <action_set>
-      <pseudo_event id="10" operation="all_stopped" operation_key="all_stopped">
+      <pseudo_event id="9" operation="all_stopped" operation_key="all_stopped">
         <attributes />
       </pseudo_event>
     </action_set>
     <inputs>
       <trigger>
-        <pseudo_event id="13" operation="stop" operation_key="fence-kiff-02_stop_0"/>
+        <pseudo_event id="12" operation="stop" operation_key="fence-kiff-02_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="16" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0"/>
+        <pseudo_event id="15" operation="stop" operation_key="dlm_stop_0" internal_operation_key="dlm:0_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="23" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0"/>
+        <pseudo_event id="22" operation="stop" operation_key="clvmd_stop_0" internal_operation_key="clvmd:0_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="30" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0"/>
+        <pseudo_event id="29" operation="stop" operation_key="shared0_stop_0" internal_operation_key="shared0:0_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="37" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0"/>
+        <pseudo_event id="36" operation="stop" operation_key="R-lxc-01_kiff-01_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="40" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0"/>
+        <pseudo_event id="39" operation="stop" operation_key="R-lxc-02_kiff-01_stop_0"/>
       </trigger>
       <trigger>
-        <pseudo_event id="47" operation="stop" operation_key="vm-fs_stop_0"/>
+        <pseudo_event id="46" operation="stop" operation_key="vm-fs_stop_0"/>
       </trigger>
       <trigger>
         <pseudo_event id="49" operation="stop" operation_key="lxc-01_kiff-01_stop_0"/>
diff --git a/pengine/test10/whitebox-imply-stop-on-fence.summary b/pengine/test10/whitebox-imply-stop-on-fence.summary
index 3ee957094..50a3446e2 100644
--- a/pengine/test10/whitebox-imply-stop-on-fence.summary
+++ b/pengine/test10/whitebox-imply-stop-on-fence.summary
@@ -2,7 +2,7 @@
 Current cluster status:
 Node kiff-01 (1): UNCLEAN (offline)
 Online: [ kiff-02 ]
-Containers: [ lxc-01_kiff-01:R-lxc-01_kiff-01 lxc-01_kiff-02:R-lxc-01_kiff-02 lxc-02_kiff-01:R-lxc-02_kiff-01 lxc-02_kiff-02:R-lxc-02_kiff-02 ]
+Containers: [ lxc-01_kiff-02:R-lxc-01_kiff-02 lxc-02_kiff-02:R-lxc-02_kiff-02 ]
 
  fence-kiff-01	(stonith:fence_ipmilan):	Started kiff-02 
  fence-kiff-02	(stonith:fence_ipmilan):	Started kiff-01 (UNCLEAN)
@@ -18,37 +18,37 @@ Containers: [ lxc-01_kiff-01:R-lxc-01_kiff-01 lxc-01_kiff-02:R-lxc-01_kiff-02 lx
      shared0	(ocf::heartbeat:Filesystem):	Started kiff-01 (UNCLEAN)
      Started: [ kiff-02 ]
      Stopped: [ lxc-01_kiff-01 lxc-01_kiff-02 lxc-02_kiff-01 lxc-02_kiff-02 ]
- R-lxc-01_kiff-01	(ocf::heartbeat:VirtualDomain):	Started kiff-01 (UNCLEAN)
+ R-lxc-01_kiff-01	(ocf::heartbeat:VirtualDomain):	FAILED kiff-01 (UNCLEAN)
  R-lxc-02_kiff-01	(ocf::heartbeat:VirtualDomain):	Started kiff-01 (UNCLEAN)
  R-lxc-01_kiff-02	(ocf::heartbeat:VirtualDomain):	Started kiff-02 
  R-lxc-02_kiff-02	(ocf::heartbeat:VirtualDomain):	Started kiff-02 
- vm-fs	(ocf::heartbeat:Filesystem):	Started lxc-01_kiff-01 
+ vm-fs	(ocf::heartbeat:Filesystem):	FAILED lxc-01_kiff-01
 
 Transition Summary:
  * Move    fence-kiff-02	(Started kiff-01 -> kiff-02)
  * Stop    dlm:0	(kiff-01)
  * Stop    clvmd:0	(kiff-01)
  * Stop    shared0:0	(kiff-01)
- * Move    R-lxc-01_kiff-01	(Started kiff-01 -> kiff-02)
+ * Recover R-lxc-01_kiff-01	(Started kiff-01 -> kiff-02)
  * Move    R-lxc-02_kiff-01	(Started kiff-01 -> kiff-02)
- * Restart vm-fs	(Started lxc-01_kiff-01)
+ * Recover vm-fs	(Started lxc-01_kiff-01)
  * Move    lxc-01_kiff-01	(Started kiff-01 -> kiff-02)
  * Move    lxc-02_kiff-01	(Started kiff-01 -> kiff-02)
 
 Executing cluster transition:
  * Pseudo action:   fence-kiff-02_stop_0
  * Fencing kiff-01 (reboot)
- * Pseudo action:   stonith_complete
- * Resource action: fence-kiff-02   start on kiff-02
- * Pseudo action:   vm-fs_stop_0
  * Pseudo action:   lxc-01_kiff-01_stop_0
  * Pseudo action:   lxc-02_kiff-01_stop_0
- * Resource action: fence-kiff-02   monitor=60000 on kiff-02
  * Pseudo action:   R-lxc-01_kiff-01_stop_0
  * Pseudo action:   R-lxc-02_kiff-01_stop_0
+ * Pseudo action:   stonith-lxc-02_kiff-01-reboot on lxc-02_kiff-01
+ * Pseudo action:   stonith-lxc-01_kiff-01-reboot on lxc-01_kiff-01
+ * Pseudo action:   stonith_complete
  * Pseudo action:   shared0-clone_stop_0
  * Resource action: R-lxc-01_kiff-01 start on kiff-02
  * Resource action: R-lxc-02_kiff-01 start on kiff-02
+ * Pseudo action:   vm-fs_stop_0
  * Resource action: lxc-01_kiff-01  start on kiff-02
  * Resource action: lxc-02_kiff-01  start on kiff-02
  * Pseudo action:   shared0_stop_0
@@ -56,16 +56,18 @@ Executing cluster transition:
  * Resource action: R-lxc-01_kiff-01 monitor=10000 on kiff-02
  * Resource action: R-lxc-02_kiff-01 monitor=10000 on kiff-02
  * Resource action: vm-fs           start on lxc-01_kiff-01
- * Resource action: vm-fs           monitor=20000 on lxc-01_kiff-01
  * Resource action: lxc-01_kiff-01  monitor=30000 on kiff-02
  * Resource action: lxc-02_kiff-01  monitor=30000 on kiff-02
  * Pseudo action:   clvmd-clone_stop_0
+ * Resource action: vm-fs           monitor=20000 on lxc-01_kiff-01
  * Pseudo action:   clvmd_stop_0
  * Pseudo action:   clvmd-clone_stopped_0
  * Pseudo action:   dlm-clone_stop_0
  * Pseudo action:   dlm_stop_0
  * Pseudo action:   dlm-clone_stopped_0
  * Pseudo action:   all_stopped
+ * Resource action: fence-kiff-02   start on kiff-02
+ * Resource action: fence-kiff-02   monitor=60000 on kiff-02
 
 Revised cluster status:
 Online: [ kiff-02 ]
diff --git a/pengine/test10/whitebox-ms-ordering.dot b/pengine/test10/whitebox-ms-ordering.dot
index 7f03a657f..bd773634e 100644
--- a/pengine/test10/whitebox-ms-ordering.dot
+++ b/pengine/test10/whitebox-ms-ordering.dot
@@ -79,4 +79,22 @@
 "lxc2_start_0 18node1" -> "lxc-ms_start_0 lxc2" [ style = bold]
 "lxc2_start_0 18node1" -> "lxc2_monitor_30000 18node1" [ style = bold]
 "lxc2_start_0 18node1" [ style=bold color="green" fontcolor="black"]
+"stonith 'reboot' lxc1" -> "lxc-ms-master_stop_0" [ style = bold]
+"stonith 'reboot' lxc1" -> "lxc-ms_demote_0 lxc1" [ style = bold]
+"stonith 'reboot' lxc1" -> "lxc-ms_stop_0 lxc1" [ style = bold]
+"stonith 'reboot' lxc1" -> "stonith_complete" [ style = bold]
+"stonith 'reboot' lxc1" [ style=bold color="green" fontcolor="orange"]
+"stonith 'reboot' lxc2" -> "lxc-ms-master_stop_0" [ style = bold]
+"stonith 'reboot' lxc2" -> "lxc-ms_stop_0 lxc2" [ style = bold]
+"stonith 'reboot' lxc2" -> "stonith_complete" [ style = bold]
+"stonith 'reboot' lxc2" [ style=bold color="green" fontcolor="orange"]
+"stonith_complete" -> "all_stopped" [ style = bold]
+"stonith_complete" -> "container1_start_0 18node1" [ style = bold]
+"stonith_complete" -> "container2_start_0 18node1" [ style = bold]
+"stonith_complete" -> "lxc-ms_promote_0 lxc1" [ style = bold]
+"stonith_complete" -> "lxc-ms_start_0 lxc1" [ style = bold]
+"stonith_complete" -> "lxc-ms_start_0 lxc2" [ style = bold]
+"stonith_complete" -> "lxc1_start_0 18node1" [ style = bold]
+"stonith_complete" -> "lxc2_start_0 18node1" [ style = bold]
+"stonith_complete" [ style=bold color="green" fontcolor="orange"]
 }
